<?php
/** 
* Class to send keys on customer email 
* @package WAOLM 
* Version corregida 1.1 
*	- Solo muestra version si el producto es variable.
*	- El correo de processing order verifica stock y depacho automatico, por si 
*     crea una variable _dispatchnow y actualiza el estado a completed
*   - Al cambiar el estado a completed, se activa el correo, el mismo verifica si el metadato
*     _dispatchnow es yes, entonces ejecuta el despacho automatico.
*	- Actualizacion menor: En despacho automático, usa post_title (Linea 239)
*/
/** 
* CONTIENE DOS HOOKS
* - custom_woocommerce_auto_complete_paid_order	(1 sola funcion)
* - woocommerce_email_customer_details (8 funciones)
* - columna nueva en orders
* 
*/

// Exit if accessed directly 
if( ! defined( 'ABSPATH' ) ) {
    exit;
}

add_action( 'woocommerce_email_order_details', 'auto_dispatch_table', 5, 4 );

//add_action( 'woocommerce_email_customer_details', 'auto_dispatch_table', 5, 4 );
//add_action( 'woocommerce_email_before_order_table', array( $this, 'auto_dispatch_table'), 20, 4 );
//add_action( 'woocommerce_email_after_order_table ', array( $this, 'auto_dispatch_table'), 20, 4 );
/*https://www.businessbloomer.com/woocommerce-add-extra-content-order-email/*/

      
//////////////////////////////////AQUI EMPIEZAN LAS FUNCIONES/////////////////////////////////////////////////

function auto_dispatch_table( $order, $sent_to_admin, $plain_text, $email ) {

        if ( $email->id == 'customer_processing_order' ) {
                global $wpdb;
                $order_id=$order->get_id();
                $despachartodo=TRUE;
                $actualizarstock=TRUE;
				$options = get_option( '_waolm_options' );
				$url_manuals_1=$options['urlmanuals'];
				$customer_email=$order->get_billing_email();//aqui
                $totalitem=0;
                $items=0;
                //////////////////
                //bucle de ITEMS de la ORDER
                //////////////////
				$i=0;//para bucle de items
				$j=0;//para blucle de combo
				$razon=$accion="";
               foreach( $order->get_items() as $item_id => $item ) {
					if($item->get_type()=='line_item'){
                        $items++;
                        $product_id_1 = $item->get_product_id();
                        $autodispatch=get_post_meta($product_id_1,'_autodispatch_option');
                        if($autodispatch[0]<>'yes'){//aqui poner un if is_set
                                $despachartodo=FALSE;
								$razon = "Despacho autom&aacute;tico no activo para uno o mas productos!";
								$accion = "Activar el despacho autom&aacute;tico para los productos, si la pol&iacute;tica de la empresa lo permite.";
                        }
                        $quantity = $item->get_quantity();
                        //las claves son cargadas para el producto raiz, no para las  variaciones
                        //las variaciones solo sirven para descontar el stock
                        $variation_id = $item->get_variation_id();
						$depu[$i][$j]['variation_id']=$variation_id;
                        if($variation_id==0){
                                $variation_id=$product_id_1;
								$muestraversion[$items]=false;
                                $variation=1;
                        }else{
								$muestraversion[$items]=true;
                                $variation=obtenervariacion($variation_id);//funcion local producto es 1pc, 2pc, etc
                        }
						$depu[$i][$j]['variation']=$variation;
                        if(escombo($product_id_1)){//funcion local, pregunta si _combos_option del producto = One, two o four
                                $productoscombo=combos($product_id_1);//funcion local, si el producto en order es combo, jala los skus
                                $l=0;
                        }else{
                                unset($productoscombo);
                                $productoscombo[0]=get_post_meta($product_id_1,'_sku',true);
                        }
						$depu[$i][$j]['productoscombo']=$productoscombo;
                        //////////////////
                        //bucle de COMBOS
                        //////////////////
						$j=0;//para bucle de combo
						if(!empty($productoscombo)){//el producto es combo pero no se ha configurado
							foreach($productoscombo as $product_sku){
									//verificar si el cliente ya recibio llaves
									$depu[$i][$j]['jota']=$j;
									$depu[$i][$j]['product_sku']=$product_sku;
									if($product_sku=='0' OR empty($product_sku)){
										$razon = "Uno o mas productos del combo NO est&aacute;n seleccionados.";
										$accion = "Despache en forma manual y revise la configuración del producto combo. As&iacute;gne los productos correspondientes.";
										$despachartodo=FALSE;
										break;
									}
									if(tiene_orden($customer_email,$product_sku)){
										$despachartodo=FALSE;
										$razon="Cliente antiguo. Revisar llaves y despachar manualmente!";
										$accion = "Despache en forma manual teniendo cuidado de no enviar llaves repetidas al cliente.";
									}
									//////////////////
									//bucle PRODUCT_ID
									//////////////////
									$depu[$i][$j]['product_sku']=$product_sku;
									$depu[$i][$j]['quantity']=$quantity;
									$despachados=0;
									$cuantas=cuantasllaves($product_sku,$variation);//Tengo por ejemplo 3 llaves con mas activaciones que variaciones
									$totalitem+=$quantity;
									$depu[$i][$j]['cuantas'][$j]=$cuantas;
									$tp=$wpdb->prefix;	
									$q="SELECT P.ID
										FROM ".$tp."posts P, ".$tp."postmeta M
										WHERE P.ID = M.post_id
										  AND P.post_type = 'product'
										  AND P.post_status = 'publish'
										  AND M.meta_key = '_sku'
										  AND M.meta_value = '$product_sku'";//dado sku, hallar id del producto en la tienda cliente
									$combo_id=$wpdb->get_var($q);//para buscar nuevo nombre de este producto
									if($cuantas >= $quantity){ /// SI  TENEMOS MAS LLAVES QUE LA CANTIDAD DEL PEDIDO
											//$product_id es el  producto, $variation es 1pc - 5pc, $priority es la prioridad
											$priority=1;
											$envio1=lasllaves($product_sku,$variation,$quantity,$priority);
											$new_name=$wpdb->get_var('SELECT post_title FROM '.$tp.'posts WHERE ID = "'.$combo_id.'"');
											for($k=0;$k<$quantity;$k++){
												if(!empty($new_name)){
													$envio1[$k]->productname=$new_name;
												}//Nombre amigable configurado en producto
												$envio1[$k]->variation=$variation;
												}
											$depu[$i][$j]['envio1']=$envio1;
											//$envio[] = json_decode($envio1);
											$envio[] = $envio1;
											if($quantity>1){
													$despachados+=count($envio1,1);// 1 para recursivo
											}else{
													$despachados+=count($envio1,1);
											}
									$depu[$i][$j]['despachados']=$despachados;
									}//if cuantas > quantity END
									if($despachados<>$quantity){
									$depu[$i][$j]['d-dif-q']="falso";
											// POR UN PRODUCTO QUE NO TENGA STOCK, SE CANCELA EL DESPACHO AUTOMATICO
											$despachartodo = FALSE;
											$razon = "Uno o mas productos no tienen el stock necesario!";
											$accion = "Despache en forma manual y aseg&uacute;rese que estos productos cuenten con activaciones suficientes!";
									}
									$j++;
									//////////////////////
									//bucle PRODUCT_ID END
									//////////////////////
									$esd_links[$product_sku]=$url_manuals_1.get_post_meta($combo_id,'_download_link',true);
							}
						}else{//if empty productoscombo
							$razon = "Uno o mas productos del combo no est&aacute;n seleccionados.";
							$accion = "Despache en forma manual y revise la configuración del producto combo. As&iacute;gne los productos correspondientes.";
							$despachartodo=FALSE;
						}//if empty productoscombo
						$i++;
                        //////////////////
                        //bucle de COMBOS END
                        //////////////////
					}//fin de si line_item

                }//foreach BUCLE DE ITEMS END
                //////////////////
                //bucle de ITEMS de la ORDER END
                //////////////////
                if($despachartodo){
                        update_post_meta($order_id,'_dispatchnow','yes');
						$salida = latabla($envio, $esd_links, $muestraversion);// El bucle de generar la tabla se ha llevado a una función
						$actualizarstock&&update_post_meta($order_id,'_esd_links',$esd_links);
						$actualizarstock&&update_post_meta($order_id,'_keys',$envio);
						$actualizarstock&&update_post_meta($order_id,'_table_keys',htmlentities($salida));

                        $order->update_status( 'completed' );
               }else{
                        update_post_meta($order_id,'_dispatchnow','no');
						$razon = "No especificado. Puede ser m&eacute;todo de pago del cliente.";
						$accion = "Verificar el m&eacute;todo de pago y realizar despacho manual cuando se haya recibido el dinero.";
                }//if despachar END
                update_post_meta($order_id,'_razon',$razon);
                update_post_meta($order_id,'_accion',$accion);
                update_post_meta($order_id,'_depu',$depu);

        } // customer_processing_order END
        if ( $email->id == 'customer_completed_order' ) {
                $order_id=$order->get_id();
                $dispatchnow=get_post_meta($order_id,'_dispatchnow');
                //////////////////
                // GRAN IF 
                //////////////////
                if($dispatchnow[0]=="yes"){
					$salida = "";
					$envio=get_post_meta($order_id,'_keys');
					$options = get_option( '_waolm_options' );
					$url_manuals_1=$options['urlmanuals'];
					if (!empty($envio)){
							$table_keys=get_post_meta($order_id,'_table_keys');
							$salida = html_entity_decode($table_keys[0]);
					}//if empty  envio END
					echo $salida;

                }//if dispatchno=yes END
                //////////////////
                // GRAN IF END
                //////////////////
        }//$email->id == 'customer_completed_order'  END
}//function END

function latabla($envio,$esd_links,$muestraversion){
	$template = '<hr>
		<h2>{titulo}</h2>
		<table class="td tablekeys" cellspacing="0" cellpadding="6" style="width: 100%; font-family: "Helvetica Neue", Helvetica, Roboto, Arial, sans-serif;border="1">
			<thead>
				<tr>
					<th class="td" scope="col" style="text-align:left">{label_nro}</th>
					<th class="td" scope="col" style="text-align:left">{label_producto}</th>
					<th class="td" scope="col" style="text-align:left">{label_llave}</th>
				</tr>
            </thead>
			<tbody>
				{datos}
			</tbody>
		</table><br><hr>
	';
	$filas = "";
	foreach($envio as $prod){
			$parimpar='par';
			foreach($prod as $fila){
				$template_fila ='<tr class={parimpar}><td style="border-top: solid 1px #e5e5e5;border-bottome: solid 1px #e5e5e5;">{nro}</td><td style="border-top: solid 1px #e5e5e5;border-bottome: solid 1px #e5e5e5;">{producto}</td><td style="border-top: solid 1px #e5e5e5;border-bottome: solid 1px #e5e5e5;">{llave}</td></tr>';
				$template_link.= '<tr class="plink" style="font-style: italic;"><td colspan=3 style="border-top: solid 1px #e5e5e5;border-bottome: solid 1px #e5e5e5;"><p>{download_link}&nbsp;<a href="{link}" target="_blank"> {producto}</a></td></tr>';
				$parimpar=$parimpar=="par"?"impar":"par";
				if($muestraversion[$k++]){//Undefined array key 2 in waolm-insert-keys-on-customer-email.php on line 307
					$fila->productname.="<p class='pversion' style='font-size:small;'>Version: ".$fila->variation." PC.</p>";
				}
				$actualizarstock&&activaciones($fila->skey,$fila->product_sku,$fila->variation,$fila->nro);
				$template_fila = str_replace('{parimpar}',$parimpar,$template_fila);
				$template_fila = str_replace('{nro}',$fila->nro,$template_fila);
				$template_fila = str_replace('{producto}',$fila->productname,$template_fila);
				$template_fila = str_replace('{llave}',$fila->skey,$template_fila);
				$filas .= $template_fila;
			}// foreach END
			$template_link = str_replace('{download_link}',__( 'Download Link:', 'waolicensemanager' ),$template_link);
			$template_link = str_replace('{link}',$esd_links[$fila->product_sku],$template_link);
			$template_link = str_replace('{producto}',$fila->productname,$template_link);
			$filas .= $template_link;
	}
	$template = str_replace('{titulo}',__( 'Your Software Activation Keys', 'waolicensemanager'),$template);
	$template = str_replace('{label_nro}',__( 'Nr.', 'waolicensemanager' ),$template);
	$template = str_replace('{label_producto}',__( 'Product', 'waolicensemanager' ),$template);
	$template = str_replace('{label_llave}',__( 'Key', 'waolicensemanager' ),$template);
	$template = str_replace('{datos}',$filas,$template);
	return $template;
}

function lasllaves($product_sku,$variation,$quantity,$priority){ // consulta sobre cpt licenses en servidor. Requiere switch_to_blog
	$external_server=get_waolm_client_option('externalserver');
	if(empty($external_server)){//tenemos servidor local obtener información mediante mysql
		return json_decode(lasllaves_server_local($product_sku,$variation,$quantity,$priority));
	}else{//servidor es externo. Obtener datos mediante json.
		$external_server=waolm_url($external_server);//formatea https://...../
		$external_server.="jsonwaolm?action=thekeys&product_sku=".$product_sku."&variation=".$variation."&quantity=".$quantity."&priority=".$priority; // url de la pagina que queremos obtener  
		$url_content = '';  
		$file = @fopen($external_server, 'r');  
		if($file){  
		//if(false){  
			while(!feof($file)) {  
				$url_content .= @fgets($file, 4096);  
			}
			$lasllaves=json_decode(trim(strip_tags($url_content)));//devolvera llaves decodificadas en array
		}  
		return $lasllaves;
	}//fin de external_server
}//function END

function activaciones($skey,$product_sku,$variation,$nro){ // consulta sobre cpt licenses en servidor. Requiere switch_to_blog
	$external_server=get_waolm_client_option('externalserver');
	if(empty($external_server)){//tenemos servidor local obtener información mediante mysql
		$ret = activaciones_server_local($skey,$product_sku,$variation,$nro);
		return $ret;
	}else{//servidor es externo. Obtener datos mediante json.
		$external_server=waolm_url($external_server);//formatea https://...../
		$external_server.="jsonwaolm?action=activations&skey=".$skey."&product_sku=".$product_sku."&variation=".$variation; // url de la pagina que queremos obtener  
		$url_content = '';  
		$file = @fopen($external_server, 'r');  
		if($file){  
		//if(false){  
			while(!feof($file)) {  
				$url_content .= @fgets($file, 4096);  
			}
			$retorno=trim(strip_tags($url_content));//true or false
		}  
		return $retorno;
	}//fin de external_server
	
}//function actualiza END

function escombo($post_id){ // consulta sobre producto en local
	$combos_option = get_post_meta($post_id,'_combos_option');
	if(empty($combos_option)||$combos_option[0]=='One'){
		return FALSE;
	}else{
		
		return TRUE;
	}
}// function escombo END 

function combos($post_id){ // consulta sobre producto en local
	$combo_products = get_post_meta($post_id,'_combo_products',true);
	return $combo_products;
}//function combos END

function obtenervariacion($variation_id){ // consulta sobre producto variable en local
	global $wpdb;
	$q="SELECT menu_order FROM {$wpdb->prefix}posts WHERE ID = {$variation_id}";
	$var=$wpdb->get_var($q);
	return $var[0]; 
} 

function cuantasllaves($product_sku,$variation){ // consulta sobre cpt licenses en servidor. Requiere switch_to_blog
	$external_server=get_waolm_client_option('externalserver');
	if(empty($external_server)){//tenemos servidor local obtener información mediante mysql
		return cuantas_llaves_server_local($product_sku,$variation);
	}else{//servidor es externo. Obtener datos mediante json.
		$external_server=waolm_url($external_server);//formatea https://...../
		$external_server.="jsonwaolm?sku=".$sku."&action=howmanykeys&product_sku=".$product_sku."&variation=".$variation; // url de la pagina que queremos obtener  
		$url_content = '';  
		$file = @fopen($external_server, 'r');  
		if($file){  
		//if(false){  
		  while(!feof($file)) {  
			$url_content .= @fgets($file, 4096);  
		  }
		  $cuantas=strip_tags($url_content);//esto devolvera un simple numero
		  fclose ($file);  
		}  
		return trim($cuantas);
	}//fin de external_server
}

function nodespachar(){}

function tiene_orden($customer_email,$product_sku){
	return false;
	//ver si este correo ya fue despachado
    global $wpdb;
	$q="SELECT DISTINCT M.meta_value
		FROM wp_posts P, wp_postmeta M
		WHERE P.ID = M.post_id
		  AND P.post_status = 'wc-completed'
		  AND P.post_type = 'shop_order'
		  AND M.meta_key = '_billing_email'";
	$emails=$wpdb->get_results($q);
	if(is_bool(array_search($customer_email,$emails))){return true;}else{return false;} 
}

function new_waolicensemanager_column( $columns = array() ) {
    // Add new columns
    $columns['waolicensemanager-status'] = 'Automatic<br>Dispatch';
    return $columns;
}

function waolicensemanager_column_content( $column ) {
    //global $the_order; // you can use the global WP_Order object here
	global $post; // is also available here
 
    if( $column == 'waolicensemanager-status' ) {

		$autodispatch=get_post_meta($post->ID, '_autodispatch_option');

//		$server=get_post_meta($the_order->ID, 'waolicensemanager_server');
	
	if(!empty($autodispatch)&&$autodispatch[0]=="yes"){
			echo "<c style='color:green'>YES</c>";
		}else{
			//echo "no";
		}
        // do stuff, ex: get_post_meta( $post->ID, 'key', true );

    }

}
//add_filter( 'manage_edit-shop_order_columns','new_waolicensemanager_column');
//add_action( 'manage_shop_order_posts_custom_column' , 'waolicensemanager_column_content' );	

add_filter( 'manage_edit-product_columns','new_waolicensemanager_column');
add_action( 'manage_product_posts_custom_column' , 'waolicensemanager_column_content' );	

/*
$options = get_option('_invoices_options');
if($options['waolicensemanagertracking']=="S"){
     add_filter( 'manage_edit-shop_order_columns','new_waolicensemanager_column');
     add_action( 'manage_shop_order_posts_custom_column' , 'waolicensemanager_column_content' );	
}
*/


/**
 * @snippet       Add Cc: or Bcc: Recipient @ WooCommerce Completed Order Email
 * @how-to        Get CustomizeWoo.com FREE
 * @author        Rodolfo Melogli
 * @compatible    WooCommerce 5
 * @donate $9     https://businessbloomer.com/bloomer-armada/
 * https://www.businessbloomer.com/woocommerce-add-to-cc-bcc-order-email-recipients/
 */
 
add_filter( 'woocommerce_email_headers', 'bbloomer_order_completed_email_add_cc_bcc', 9999, 3 );
 
function bbloomer_order_completed_email_add_cc_bcc( $headers, $email_id, $order ) {
    if ('customer_completed_order'==$email_id){
		$adm_email=get_option('admin_email');
        $headers .= "Cc: Copia para admin <".$adm_email.">\r\n"; // delete if not needed
    }
    return $headers;
}

function template(){
	$template = '
	<hr><h2>{titulo}</h2>
	<table class="td tablekeys" cellspacing="0" cellpadding="6" style="width: 100%; font-family: "Helvetica Neue", Helvetica, Roboto, Arial, sans-serif;" border="1">
		<thead>
			<tr>
				<th class="td" scope="col" style="text-align:{text-align}">{tit_nro}</th>
				<th class="td" scope="col" style="text-align:{text-align}">{tit_product}</th>
				<th class="td" scope="col" style="text-align:{text-align}">{tit_key}</th>
			</tr>
		</thead>
		<tbody>
		{filas}
		</tbody>
	</table>
	<br><hr>
	';
	return $template;
}

function genera_html_sus_llaves($envio,$esd_links){
	
}




//////////////////////////////////AQUI TERMINAN LAS FUNCIONES/////////////////////////////////////////////////
