<?php
/*
 * DESPACHO MANUAL
 * Ahora en POO con clase
 * Cuando no se realizó el despacho automático 
*/
defined( 'ABSPATH' ) or die; 


class susllaves {
	private $mensajes = array();
	private $mensaje;
	private $formllaves=FALSE;
	private $templo="";

    public function __construct() {
		add_action('save_post', array($this,'procesar_llaves_manualmente'), 5, 3);
		add_action('woocommerce_admin_order_data_after_order_details',array($this,'susllaves'),20);//sale en edit de order ES FUNCION DE CLIENTE
    }
	/// Mostrar las llaves compradas por el cliente en la pagina de edit order
	function susllaves($post){//sale en edit de order
		$res1=get_post_meta( $post->get_id(),'_keys',true );
		$template="
			<div class='form-field form-field-wide wc-customer-user' style='background-color:#fff;border:solid #d7cad2 1px;border-radius:5px;padding:5px;margin-bottom:5px;width:98%'>
			DESPACHO AUTOMATICO:<hr style='color:#d7cad2;'>
				{contenido}
			</div>
		";
		if(!empty($res1)){
			$res=$res1[0];
			$template_contenido = '
			<ul style="list-style: square;margin-left:30px;">
				{lis}
			</ul>
			';
			$lis = "";
			foreach($res1 as $grupo){
				foreach($grupo as $fila){
					$lis.='<li>'.$fila->productname.':  <b>'.$fila->skey.'</b></li>';
				}//foreach fila END
			}// foreach grupo END
			$template_contenido= str_replace('{lis}',$lis,$template_contenido);
		}else{
			$template_contenido ='
			<table>
				<tr><td width=30%>DESPACHADO:</td><td>NO</td><tr>
				<tr style="background-color:#F6F6F6;"><td>RAZON: </td><td>{razon}</td></tr>
				<tr><td>ACCION A TOMAR:</td><td>{accion}</td></tr>
			</table>';
			$template_contenido= str_replace('{razon}',get_post_meta($post->get_id(),'_razon',true),$template_contenido);
			$template_contenido= str_replace('{accion}',get_post_meta($post->get_id(),'_accion',true),$template_contenido);
			add_action('woocommerce_admin_order_data_after_billing_address', array($this,'despacho_manual'),30);
		}
		$template= str_replace("{contenido}",$template_contenido,$template);
		echo  $template;
	}	
	// Si no se ejecuto despacho automatico, mostrar formulario para hacer despacho semi manual
	function despacho_manual($order){
		$template ='
		<style>
			.despacho-manual{}
			.despacho-manual tr td{padding:0px!important;}
			.uno{width:50%!important;}
			.dos{width:40%!important;}
			.tres{width:10%!important;text-align:center;}
		</style>
			<div class="form-field form-field-wide wc-customer-user" style="background-color:#fff;border:solid #d7cad2 1px;border-radius:5px;padding:5px;margin-bottom:5px;width:98%">
			DESPACHO MANUAL: (EN CONSTRUCCION, NO USAR TODAVIA)<hr style="color:#d7cad2;">
			{mensajes}
				<table class="wp-list-table despacho-manual">
					<tr>
						<th>PRODUCTO</th>
						<th>LLAVE</th>
						<th>SKU</th>
					</tr>
					{filas1}
				</table>

			</div>
			<input type="hidden" name="order_id" value="{order_id}">
			<button name="accion" value="guardar" type="submit">Guardar</button>
			<button name="accion" value="enviar" type="submit" {disabled}>Enviar email</button>
			{templo}
		';
		$items = $order->get_items();
		//print_r($items);
		$filas = "";
		$keys_saved = get_post_meta($order->get_id(),'_tempo_keys');
		//print_r($keys_saved);
		if (count($keys_saved) == 0){$keys_saved = array(array(array('skey'=>'nada')));}
		$k_items=0;//contador de items
		$l_products=0;//contador de productos que yo puse
		$m_filasreales=0;//contador de filas almacenadas en _tempo_keys
		$estantodas=true;
		foreach ($items as $item_id => $item) {//bucle de items
			$quantity = $item->get_quantity();
			$product = $item->get_product();
			$variation_id = $product->get_id(); // Esto puede ser un variation_id si el producto es una variación
			$parent_id = $product->get_parent_id(); // Esto obtiene el product_id del producto principal para variaciones (0 si no lo es)
			$product_id = $parent_id ? $parent_id : $variation_id;
			//$product_id = $product->get_id();
			$product_name = $item->get_name(); // Obtiene el nombre del producto
			$nombrecombo = FALSE;
			$inc_skus=1;
			if(escombo($product_id)){//en waolm-insert-keys-on-customer-email.php, pregunta si _combos_option del producto = One, two o four
					$skus=combos($product_id);//funcion local, si el producto en order es combo, jala los skus
					$inc_skus=count($skus);
					$nombrecombo = TRUE;
			}else{
				// verificar combo por sku cuando el producto combo no ha sido configurado
				if($this->escomboporsku($product->get_sku)){
					$skus=$this->comboporsku($product->get_sku);
					$nombrecombo = TRUE;
				}else{
					unset($skus);
					//$productoscombo[0]=get_post_meta($product_id,'_sku',true);
					$skus[0] = $product ? $product->get_sku():"";//asignamos el sku del producto actual como unico elemento del array
				}
			}
			$j_skus=0;
			foreach($skus as $sku){//bucle de combo
				if($nombrecombo){
					$product_name = $this->get_product_name_by_sku($sku);
				}
				for($i=1;$i<=$quantity;$i++){ // bucle de cantidad
					$template_fila = '<tr><td class="uno">{nomproducto}</td><td class="dos">{entrada}</td><td class="tres">{sku}</td></tr>';
					$t=$i-1;//cantidad menos uno
					//$saved_key = isset($keys_saved[$k_items][$j_skus][$i-1]->skey)?$keys_saved[$k_items][$j_skus][$i-1]->skey:"";
					$saved_key = isset($keys_saved[0][$m_filasreales][$t]->skey)?$keys_saved[0][$m_filasreales][$t]->skey:"";
					if($saved_key==""){$estantodas=false;}
					$entrada =  '<input type="text" name="llaves['.esc_attr($sku).'][]" value="'.$saved_key.'" />';
					//$nombre = substr(esc_html($product_name),0,30)."<br><b style='color:blue;'>0-".$m_filasreales."-".$t."</b>";
					$nombre = esc_html($product_name);
					$nombre = str_replace('Microsoft','',$nombre);
					$nombre = str_replace('1 PC','',$nombre);
					$nombre = str_replace('2 PC','',$nombre);
					$nombre = str_replace('3 PC','',$nombre);
					$nombre = str_replace('4 PC','',$nombre);
					$nombre = str_replace('5 PC','',$nombre);
					$nombre = str_replace(' - ','',$nombre);
					$nombre = substr($nombre,0,35);
					$template_fila = str_replace('{nomproducto}', $nombre,$template_fila); 
					$template_fila = str_replace('{entrada}', $entrada,$template_fila);
					$template_fila = str_replace('{sku}', $sku,$template_fila);
					$filas.=$template_fila;
					$l_products++;
				}
				$j_skus++;
				$m_filasreales++;
			}
			$k_items++;
		}
		$disabled = "";
		if(!$estantodas){
			$this->setMensajes("Debes completar llaves antes de enviarlas!","rojo");
			$disabled = " disabled ";
			$templo='';
		}else{
			$templo = get_post_meta($order->get_id(),'_table_keys',true); 
		}
		$mensajes = $this->showMensajes();  
		$template = str_replace('{disabled}', $disabled,$template);
		$template = str_replace('{mensajes}', $mensajes,$template);
		$template = str_replace('{filas1}', $filas,$template);
		$template = str_replace('{order_id}', $order->get_id(),$template);
		$template = str_replace('{templo}', $templo, $template);
		echo $template;
	}
	// Formulario para pegar llaves y enviar semi manualmente
	function procesar_llaves_manualmente(){
		if(isset($_POST['llaves'])){
			$accion = isset($_POST['accion'])?$_POST['accion']:"naca";
			switch ($accion){
				case "guardar":
					$this->guardar_keys();
					break;
				case "enviar":
					//$mensaje = $this->guardar_keys();
					$this->enviar_keys();
					break;
			}
		}
	}
	// Funcion para guardar las llaves antes de enviarlas  
	function guardar_keys(){
		$llaves = $_POST['llaves'];
		$order_id = $_POST['order_id'];
		$esd_links = array();
		$newkeys = array();
		foreach($llaves as $sku => $keys){
			$i=1;
			unset($newkeys);
			foreach($keys as $key){
				$objeto = new stdClass();
				$objeto->nro = $i;
				$objeto->keyid = '0';
				$objeto->skey = $key;
				//$objeto->productname = 'naranjas';
				$objeto->productname = $this->get_product_name_by_sku($sku);
				$objeto->priority = $i++;
				$objeto->product_sku = $sku;
				$objeto->variation = '1';
				$newkeys[]=$objeto;

				$options = get_option( '_waolm_options' );
				$url_manuals=$options['urlmanuals'];
				$product_id = $this->get_product_id_by_sku($sku);
				$esd_links[$sku]=$url_manuals.get_post_meta($product_id,'_download_link',true);
			}
			$groups[]=$newkeys;
		}
		if(update_post_meta($order_id,'_tempo_keys',$groups)){
			$this->setMensajes("Llaves guardadas con &eacute;xito!","verde");
		}else{
			//$this->setMensajes("Error al actualizar _tempo_keys!","rojo");
		}
		if(update_post_meta($order_id,'_esd_links',$esd_links)){
		}else{
			//$this->setMensajes("Error al actualizar _esd_links!","rojo");
		}
		//if (!$this->validar_keys()){
			//$mensaje = $this->setMensajes("Debe llenar todas las llaves!","rojo");
		//}//fin de validar keys
		//return $mensaje; //borrar ya no se usa
	}
	// Validar que se peguen todas las llaves
	function validar_keys(){
		//return true;
		$llaves = $_POST['llaves'];
		$validado=TRUE;
		foreach($llaves as $sku => $keys){
			foreach($keys as $key){
				if($key==""){
					$validado=FALSE;
				}
			}
		}
		return $validado;
	}
	// Funcion para enviar mediante smtp las llaves recien pegadas
	function enviar_keys(){
		$order_id = $_POST['order_id'];
		$retorno = true;
		$razon = get_post_meta($order_id,'_razon',true);
        $accion = get_post_meta($order_id,'_accion',true);
		// Asegúrate de que tienes el ID de la orden. Es una buena práctica validar y sanear las entradas.
		if ( isset( $_POST['order_id'] ) && ! empty( $_POST['order_id'] ) ) {
			$order_id = intval( $_POST['order_id'] ); // Usamos intval para asegurarnos de que es un número.
			$tempo_keys = get_post_meta($order_id, '_tempo_keys',true);//obtener llaves
			$esdlinks = get_post_meta($order_id, '_esd_links',true);//obtener esd_links
			$template = template();//en waolm-insert-keys-on-customer-email.php
			$template = $this->poblate_template_with_keys($template,$tempo_keys,$esdlinks);
			//$this->templo = "12345".$template;// esto ya vimos que no sirve, usar update_post_meta en su lugar
			//update_post_meta($order_id,'_table_keys1', $template);
			update_post_meta($order_id,'_keys', $tempo_keys);
			update_post_meta($order_id,'_table_keys', $template);
			// Instancia la orden utilizando el ID
			$order = wc_get_order( $order_id );
			// Verifica si la orden existe antes de intentar actualizarla
			if ( $order ) {
				// Actualiza el estado de la orden a 'completed'
				update_post_meta($order_id,'_keys', $tempo_keys);
                update_post_meta($order_id,'_dispatchnow','yes');
				$order->update_status( 'completed', 'Pedido completado automáticamente.' ); // El segundo parámetro es una nota opcional.
				// Si necesitas hacer algo más después de actualizar el estado, puedes hacerlo aquí.
			} else {
				// Manejar el caso en que la orden no se encuentra o no existe
				$retorno =false;
				$razon = "No se instanci&oacute; la orden.";
				$accion = "Comunique al Dpto. desarrollo. (waolm-sus-llaves-en-edit-order 261).";
			}
		} else {
			// Manejar el caso en que el ID de la orden no se pasa correctamente
			$retorno =false;
			$razon = "order_id no recibida.";
			$accion = "Comunique al Dpto. desarrollo. (waolm-sus-llaves-en-edit-order 248).";
		}
		update_post_meta($order_id,'_razon',$razon);
		update_post_meta($order_id,'_accion',$accion);
		return $retorno;
	}

	function poblate_template_with_keys($template, $keys, $esdlinks){
		$text_align='center';
		$template = str_replace('{titulo}',__( 'Your Software Activation Keys', 'waolicensemanager' ),$template);
		$template = str_replace('{text-align}',$text_align,$template);
		$template = str_replace('{tit_nro}',__( 'Nr.', 'waolicensemanager' ),$template);
		$template = str_replace('{tit_product}',__( 'Product', 'waolicensemanager' ),$template);
		$template = str_replace('{tit_key}',__( 'Key', 'waolicensemanager' ),$template);
		$trs="";
		foreach($keys as $line_items){
			$parimpar='par';
			foreach($line_items as $product){
				$parimpar=$parimpar=="par"?"impar":"par";
				$fila = '<tr class="{parimpar}"><td>{nro}</td><td>{nomproducto}</td><td>{llave}</td></tr>';
				$fila = str_replace('{parimpar}',$parimpar,$fila);
				$fila = str_replace('{nro}',$product->nro,$fila);
				$fila = str_replace('{nomproducto}',$product->productname,$fila);
				$fila = str_replace('{llave}',$product->skey,$fila);
				$trs.=$fila;
			} 
			$fila = '<tr><td colspan="3" >{downloadlinktext}&nbsp;{downloadlink}</td></tr>';
			$fila = str_replace('{downloadlinktext}',__( 'Download Link:', 'waolicensemanager' ),$fila);
			$ellink = '<a href="'.$esdlinks[$product->product_sku].'">'.$product->productname.'</a>';
			$fila = str_replace('{downloadlink}',$ellink,$fila);
			$trs.=$fila;
		}
		$template = str_replace('{filas}',$trs,$template);
		return $template;
	}
	// Cargar mensajes para ser mostrados 
	public function setMensajes($mensaje,$color){
		$mensaje_admin = get_option('mensaje_admin');
		$fila = array("mensaje"=>$mensaje,"color"=>$color);
		$mensaje_admin[]=$fila;
		update_option('mensaje_admin',$mensaje_admin);
		return $mensaje;
	}
	// Devuelve los mensajes cargados, formateados entre etiquetas p 
	public function showMensajes(){
		$mensajes_admin = get_option('mensaje_admin',array());
		$salida1 = "";
		if(count($mensajes_admin)>0){
			$salida1 .= "";
			foreach($mensajes_admin as $filas){
				$salida1 .= $this->formato($filas['mensaje'],$filas['color']);
			}
		}
		delete_option('mensaje_admin');
		return $salida1;
	}
	// Funcion para facilitar el formato
	function formato($mensaje,$color="verde"){
		$template = '<p style="{estilo}">{mensaje}</p>';
		$template = str_replace('{mensaje}',$mensaje,$template);
		switch($color){
			case "rojo":
				$template = str_replace('{estilo}',"margin:1px;color:#fb0808;background-color:#FFE6E6;",$template);
				break;
			case "verde":
			default:
				$template = str_replace('{estilo}',"margin:1px;color:#114232;background-color:#87A922;",$template);
		}
		return $template;
	}
	// Destruir
	public function __destruct() {
        // Limpieza o cierre de recursos aquí
    }
	// Verificar si un producto es combo mediante su sku (W10P-O21PP es combo por que su sku es la union de 2 skus mediante un guion)
	function escomboporsku($sku){
		$skus = explode('-',$sku);
		return count($skus)>1?true:false;
	}
	// Mediante la funcion explode, devolver los sku de los productos del combo
	function comboporsku($sku){
		$skus = explode('-',$sku);
		return $skus;
	}
	// Obtener id por sku
	function get_product_id_by_sku($sku) {
		global $wpdb; // Hace global el objeto $wpdb para interactuar con la base de datos
		// Prepara y ejecuta una consulta para buscar el ID del producto basado en su SKU
		$sql = $wpdb->prepare("SELECT post_id FROM $wpdb->postmeta WHERE meta_key='_sku' AND meta_value=%s LIMIT 1", $sku);
		$product_id = $wpdb->get_var($sql);
		if ($product_id) {
			return $product_id; // Retorna el ID del producto si se encuentra
		} else {
			return null; // Retorna null si no se encuentra un producto con ese SKU
		}
	}
	// Obtener nombre de producto por su sku
	function get_product_name_by_sku($sku) {
		global $wpdb;
		
		// Consulta para obtener el ID del producto basado en el SKU
		$product_id = $wpdb->get_var($wpdb->prepare("
			SELECT post_id
			FROM $wpdb->postmeta
			WHERE meta_key='_sku' AND meta_value=%s
			LIMIT 1
		", $sku));
		
		if ($product_id) {
			// Obtiene el producto basado en el ID y luego el nombre
			$product_name = $wpdb->get_var($wpdb->prepare("
				SELECT post_title
				FROM $wpdb->posts
				WHERE ID='%s'
				LIMIT 1
			", $product_id));
			if($product_name){
				return $product_name;
			}
		}
		
		return "No product for this SKU.".$product_id;
	}
	// Función para recorrer recursivamente la estructura y extraer los valores de "skey"
	function extraerSkeysFiltrados($elemento, $productSkuFiltrar, &$skeys = []) {
		if (is_array($elemento) || is_object($elemento)) {
			foreach ($elemento as $key => $value) {
				if (is_object($value)) {
					// Verifica si el objeto tiene "skey" y el "product_sku" deseado
					if (isset($value->skey) && isset($value->product_sku) && $value->product_sku == $productSkuFiltrar) {
						$skeys[] = $value->skey;
					}
				}
				if (is_array($value) || is_object($value)) {
					$this->extraerSkeysFiltrados($value, $productSkuFiltrar, $skeys); // Llama a la función recursivamente
				}
			}
		}
		return $skeys;
	}
	// Funcion para obtener las llaves compradas, por sku y correo
	function llaves_por_sku_y_correo($email,$buscaEsteSku){
		global $wpdb;
		// Preparar consulta para obtener IDs de órdenes
		$query = "
			SELECT posts.ID
			FROM {$wpdb->posts} AS posts
			INNER JOIN {$wpdb->postmeta} AS postmeta ON posts.ID = postmeta.post_id 
			WHERE posts.post_type = 'shop_order'
			AND posts.post_status = 'wc-completed'
			AND postmeta.meta_key = '_billing_email'
			AND postmeta.meta_value = %s
		";

		// Ejecutar la consulta
		$order_ids = $wpdb->get_col($wpdb->prepare($query, $email));
		// Paso 2 y 3: Buscar en los metadatos y extraer "skey"
		$skeysFiltrados = array();
		foreach ($order_ids as $order_id) {
			$tempo_keys = get_post_meta($order_id, '_keys');
			if ($tempo_keys) {
				$laskeys = $this->extraerSkeysFiltrados($tempo_keys, $buscaEsteSku);
				foreach ( $laskeys as $skey) {
					$skeysFiltrados[] = $skey;
				}
			}
		}
		// Imprimir los valores de "skey" encontrados
		return $skeysFiltrados;
	}
} 

// Ejemplo de uso:
$susllavesObject = new susllaves();

// Buscar llaves compradas por el cliente por sku y email
$email = "sarbjeet.sokhi@gmail.com";
$sku = "O19S";
$skeysFiltrados = $susllavesObject->llaves_por_sku_y_correo($email,$sku);
update_option('_depu',$skeysFiltrados);


